	ORG $1000-2
	DW $1000
	
	include "!playerv.asm"
	
OFS = 0	
music_beg
	include "digimusic.asm"
	include "digiplay.asm"
	include "!player.asm"
	include "!player_data.asm"
	include "music.asm"
music_end

	ORG $2000
	
temp	= $F0	
dest	= $F2
	;
time		= $0EB8
max_raster	= time + 47
max_raster_chr	= time + 40
track_info	= $0F70

Print16	macro addr
	LDA #"$"
	JSR $FFD2
	LDA #addr >> 8
	JSR $FB10
	LDA #addr & 255
	JSR $FB10
	endm
	
start
	;
	; save?
	;
;	LDA #music_beg & 255
;	STA $F4
;	LDA #music_beg >> 8
;	STA $F5
;	;
;	LDA #$01	; logical number
;	LDX #$08	; device number (8=disk)
;	LDY #$01	; secondary address
;	JSR $FFBA	; KERNAL: SETLFS
;	LDA #fname_end - fname
;	LDX #fname & 255
;	LDY #fname >> 8
;	JSR $FFBD	; KERNAL: SETNAM (Set length and filename address)
;	;
;	LDA #$F4	; A=zp address
;	LDX #(music_end & 255)
;	LDY #(music_end >> 8)
;	JSR $FFD8	; KERNAL: SAVESP
	;
	; ---
	;
	JSR $FF4F
	DB $93,$90
	DB $0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D
	DB $0D,$0D,$0D,$0D,$0D
	DB "ELAPSED TIME  : 00:00 ( )",$0D
	DB "MAXIMUM RASTER: 00    ( )",$0D
	DB $90,"MAX. ROOM     : $1000 - $1FFF",$0D
	DB $90,"MUSIC         : "
	;
	DB 0
	;
	Print16 (music_beg-OFS)
	JSR $FF4F
	DB " - ",0
	Print16 (music_end-OFS)
	;
	LDA #$00
	STA time+7
	STA max_raster
	;
	LDA #$41
	STA $FF19
	LDA #$51
	STA $FF15
	;
	; ---
	;
	LDY #$00
	LDX #$00
delay	INX
	BNE delay
	INY
	BNE delay
	;
	SEI
	STA $FF3F
	;
	; ----------
	;
	LDA #$40
	STA dest+1
	LDY #$00
	STY dest
cl2	TYA
cl1	STA (dest),y
	INY
	BNE cl1
	;    
	INC dest+1
	LDA dest+1
	CMP #$FD
	BNE cl2
	;
	JSR PLAYER_FREQ_INIT - OFS
	JSR digi_init
	;
	; ----------
	;
	CLI  
	;
sync0	LDA $FF1D
	CMP #$CC
	BNE sync0
	;
	DEC $FF19
	LDA $FF1D
	STA r_start+1
	;
	JSR PLAYER - OFS
	;
vol_down
	LDA #$00
	BEQ no_vol_down
	;
vol_delay
	LDA #$00
	CLC
	ADC #$01
	AND #$0F
	STA vol_delay+1
	BNE no_vol_down
	;
	;LDA VOLUME
	;CLC
	;ADC #$09
	;CMP #21*9
	;BNE do_vol_down
	JMP $FFF6
do_vol_down
	;STA VOLUME
no_vol_down
	;
	INC $FF19
	;
	LDA $FF1D
	SEC
r_start	SBC #$00
	CMP max_raster
	BCC not_larger
	;
	STA max_raster
	;
	AND #$0F
	TAX
	LDA hex_char,x
	STA max_raster_chr+1
	;
	LDA max_raster
	LSR a
	LSR a
	LSR a
	LSR a
	TAX
	LDA hex_char,x
	STA max_raster_chr
	;
not_larger
	;
	JSR INC_TIMER
	;
	JSR dump_track_info
	;
	;LDA $FF12
	;AND #$03
	;JSR $FB10
	;LDA $FF0E
	;JSR $FB10
	;LDA #$0D
	;JSR $FFD2
	;
kdelay	LDY #$00
	BEQ kcheck
	DEY 
	JMP kend
	
kcheck	LDA #$BF
	STA $FD30
	STA $FF08
	LDA $FF08
	CMP #$F7
	BNE x5
	;
	LDA #$21
	STA $FF15
	STA vol_down+1
	; do something on keypress
	;
x5	;
	LDY #$04
kend	STY kdelay+1
	;
	JMP sync0
	;
	
INC_TIMER
	LDA time+7
	CLC
	ADC #$01
	CMP #50
	BNE inc1
	;
	LDX #$05
inc2	DEX 
	CPX #$02
	BEQ inc2
	LDA time,x
	CLC
	ADC #$01
	CMP time_end,x
	BNE inc3
	LDA #$30
inc3	STA time,x
	CMP #$30
	BEQ inc2
	;
	LDA #$00
inc1	STA time+7
	;
	RTS
time_end
	DB $3A,$3A,$3A,$36,$3A
hex_char
	DB "0123456789",1,2,3,4,5,6
	
dump_track_info
	LDA #track_info & 255
	STA dest
	LDA #track_info >> 8
	STA dest+1
	;
	LDX #$00
dt2	STX x_save+1
	LDA CH1_LO,x
	STA temp
	LDA CH1_HI,x
	STA temp+1
	;
	LDX temp
	JSR write_word
	JSR add_dest_1
	;
	LDY #$00
dt1	LDA (temp),y
	JSR write_byte
	JSR add_dest_1
	INY
	CPY #$08
	BNE dt1
	;
	LDA #$0B
	JSR add_dest
	;
x_save	LDX #$00
	INX
	CPX #$02
	BNE dt2
	;
	RTS
	
write_word
	STX x_sav2+1
	JSR write_byte
x_sav2	LDA #$00
	;
write_byte
	STY y_save+1
	PHA
	LSR a
	LSR a
	LSR a
	LSR a
	TAX
	LDA hex_char,x
	LDY #$00
	STA (dest),y
	PLA
	AND #$0F
	TAX
	LDA hex_char,x
	INY
	STA (dest),y
	;
	LDA #$02
	JSR add_dest
y_save	LDY #$00
	RTS

add_dest_1
	LDA #$01
add_dest
	CLC
	ADC dest
	STA dest
	BCC *+4
	INC dest+1
	RTS
	
;[eof]